- [HTTP request](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#body.aspect_1)
- [Try it!](https://docs.cloud.google.com/gemini-enterprise-cx/ai-commerce-search/reference/rest/v2/projects.locations.catalogs.servingConfigs/search.md.txt#try-it)

Performs a search.

This feature is only available for users who have Retail servingConfigs.search enabled. Enable Retail servingConfigs.search on Cloud Console before using this feature.

### HTTP request

`POST https://retail.googleapis.com/v2/{placement=projects/*/locations/*/catalogs/*/servingConfigs/*}:search`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `placement` | `string` Required. The resource name of the Retail servingConfigs.search serving config, such as `projects/*/locations/global/catalogs/default_catalog/servingConfigs/default_serving_config` or the name of the legacy placement resource, such as `projects/*/locations/global/catalogs/default_catalog/placements/default_search`. This field is used to identify the serving config name and the set of models that are used to make the search. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "branch": string, "query": string, "visitorId": string, "userInfo": { object (`UserInfo`) }, "pageSize": integer, "pageToken": string, "offset": integer, "filter": string, "canonicalFilter": string, "orderBy": string, "facetSpecs": [ { object (`FacetSpec`) } ], "dynamicFacetSpec": { object (`DynamicFacetSpec`) }, "boostSpec": { object (`BoostSpec`) }, "queryExpansionSpec": { object (`QueryExpansionSpec`) }, "variantRollupKeys": [ string ], "pageCategories": [ string ], "searchMode": enum (`SearchMode`), "personalizationSpec": { object (`PersonalizationSpec`) }, "labels": { string: string, ... }, "entity": string, "conversationalSearchSpec": { object (`ConversationalSearchSpec`) }, "tileNavigationSpec": { object (`TileNavigationSpec`) }, "languageCode": string, "regionCode": string, "placeId": string, "userAttributes": { string: { object (`StringList`) }, ... }, "spellCorrectionSpec": { object (`SpellCorrectionSpec`) } } ``` |

| Fields ||
|---|---|
| `branch` | `string` The branch resource name, such as `projects/*/locations/global/catalogs/default_catalog/branches/0`. Use "default_branch" as the branch ID or leave this field empty, to search products under the default branch. |
| `query` | `string` Raw search query. If this field is empty, the request is considered a category browsing request and returned results are based on `filter` and `pageCategories`. |
| `visitorId` | `string` Required. A unique identifier for tracking visitors. For example, this could be implemented with an HTTP cookie, which should be able to uniquely identify a visitor on a single device. This unique identifier should not change if the visitor logs in or out of the website. This should be the same identifier as `UserEvent.visitor_id`. The field must be a UTF-8 encoded string with a length limit of 128 characters. Otherwise, an INVALID_ARGUMENT error is returned. |
| `userInfo` | ``object (`UserInfo`)`` User information. |
| `pageSize` | `integer` Maximum number of `Product`s to return. If unspecified, defaults to a reasonable value. The maximum allowed value is 120. Values above 120 will be coerced to 120. If this field is negative, an INVALID_ARGUMENT is returned. |
| `pageToken` | `string` A page token `SearchResponse.next_page_token`, received from a previous `SearchService.Search` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `SearchService.Search` must match the call that provided the page token. Otherwise, an INVALID_ARGUMENT error is returned. |
| `offset` | `integer` A 0-indexed integer that specifies the current offset (that is, starting result location, amongst the `Product`s deemed by the API as relevant) in search results. This field is only considered if `pageToken` is unset. If this field is negative, an INVALID_ARGUMENT is returned. |
| `filter` | `string` The filter syntax consists of an expression language for constructing a predicate from one or more fields of the products being filtered. Filter expression is case-sensitive. For more information, see [Filter](https://cloud.google.com/retail/docs/filter-and-order#filter). If this field is unrecognizable, an INVALID_ARGUMENT is returned. |
| `canonicalFilter` | `string` The default filter that is applied when a user performs a search without checking any filters on the search page. The filter applied to every search request when quality improvement such as query expansion is needed. In the case a query does not have a sufficient amount of results this filter will be used to determine whether or not to enable the query expansion flow. The original filter will still be used for the query expanded search. This field is strongly recommended to achieve high search quality. For more information about filter syntax, see `SearchRequest.filter`. |
| `orderBy` | `string` The order in which products are returned. Products can be ordered by a field in an `Product` object. Leave it unset if ordered by relevance. OrderBy expression is case-sensitive. For more information, see [Order](https://cloud.google.com/retail/docs/filter-and-order#order). If this field is unrecognizable, an INVALID_ARGUMENT is returned. |
| `facetSpecs[]` | ``object (`FacetSpec`)`` Facet specifications for faceted search. If empty, no facets are returned. A maximum of 200 values are allowed. Otherwise, an INVALID_ARGUMENT error is returned. |
| `dynamicFacetSpec (deprecated)` | ``object (`DynamicFacetSpec`)`` Deprecated. Refer to <https://cloud.google.com/retail/docs/configs#dynamic> to enable dynamic facets. Do not set this field. The specification for dynamically generated facets. Notice that only textual facets can be dynamically generated. |
| `boostSpec` | ``object (`BoostSpec`)`` Boost specification to boost certain products. For more information, see [Boost results](https://cloud.google.com/retail/docs/boosting). Notice that if both `ServingConfig.boost_control_ids` and `SearchRequest.boost_spec` are set, the boost conditions from both places are evaluated. If a search request matches multiple boost conditions, the final boost score is equal to the sum of the boost scores from all matched boost conditions. |
| `queryExpansionSpec` | ``object (`QueryExpansionSpec`)`` The query expansion specification that specifies the conditions under which query expansion occurs. For more information, see [Query expansion](https://cloud.google.com/retail/docs/result-size#query_expansion). |
| `variantRollupKeys[]` | `string` The keys to fetch and rollup the matching `variant` `Product`s attributes, `FulfillmentInfo` or `LocalInventory`s attributes. The attributes from all the matching `variant` `Product`s or `LocalInventory`s are merged and de-duplicated. Notice that rollup attributes will lead to extra query latency. Maximum number of keys is 30. For `FulfillmentInfo`, a fulfillment type and a fulfillment ID must be provided in the format of "fulfillmentType.fulfillmentId". E.g., in "pickupInStore.store123", "pickupInStore" is fulfillment type and "store123" is the store ID. Supported keys are: - colorFamilies - price - originalPrice - discount - variantId - inventory(placeId,price) - inventory(placeId,originalPrice) - inventory(placeId,attributes.key), where key is any key in the `Product.local_inventories.attributes` map. - attributes.key, where key is any key in the `Product.attributes` map. - pickupInStore.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "pickup-in-store". - shipToStore.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "ship-to-store". - sameDayDelivery.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "same-day-delivery". - nextDayDelivery.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "next-day-delivery". - customFulfillment1.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "custom-type-1". - customFulfillment2.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "custom-type-2". - customFulfillment3.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "custom-type-3". - customFulfillment4.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "custom-type-4". - customFulfillment5.id, where id is any `FulfillmentInfo.place_ids` for `FulfillmentInfo.type` "custom-type-5". If this field is set to an invalid value other than these, an INVALID_ARGUMENT error is returned. |
| `pageCategories[]` | `string` Optional. The categories associated with a category page. Must be set for category navigation queries to achieve good search quality. The format should be the same as `UserEvent.page_categories`; To represent the full path of category, use '\>' sign, with one space on each side, to separate different hierarchies. If '\>' is part of the category name, replace it with other character(s). Category pages include special pages such as sales or promotions. For instance, a special sale page may have the category hierarchy: "pageCategories" : \["Sales \> 2017 Black Friday Deals"\]. |
| `searchMode` | ``enum (`SearchMode`)`` The search mode of the search request. If not specified, a single search request triggers both product search and faceted search. |
| `personalizationSpec` | ``object (`PersonalizationSpec`)`` The specification for personalization. Notice that if both `ServingConfig.personalization_spec` and `SearchRequest.personalization_spec` are set. `SearchRequest.personalization_spec` will override `ServingConfig.personalization_spec`. |
| `labels` | `map (key: string, value: string)` The labels applied to a resource must meet the following requirements: - Each resource can have multiple labels, up to a maximum of 64. - Each label must be a key-value pair. - Keys have a minimum length of 1 character and a maximum length of 63 characters and cannot be empty. Values can be empty and have a maximum length of 63 characters. - Keys and values can contain only lowercase letters, numeric characters, underscores, and dashes. All characters must use UTF-8 encoding, and international characters are allowed. - The key portion of a label must be unique. However, you can use the same key with multiple resources. - Keys must start with a lowercase letter or international character. For more information, see [Requirements for labels](https://cloud.google.com/resource-manager/docs/creating-managing-labels#requirements) in the Resource Manager documentation. |
| `entity` | `string` The entity for customers that may run multiple different entities, domains, sites or regions, for example, `Google US`, `Google Ads`, `Waymo`, `google.com`, `youtube.com`, etc. If this is set, it should be exactly matched with `UserEvent.entity` to get search results boosted by entity. |
| `conversationalSearchSpec` | ``object (`ConversationalSearchSpec`)`` Optional. This field specifies all conversational related parameters addition to traditional retail search. |
| `tileNavigationSpec` | ``object (`TileNavigationSpec`)`` Optional. This field specifies tile navigation related parameters. |
| `languageCode` | `string` Optional. The BCP-47 language code, such as "en-US" or "sr-Latn" [list](https://www.unicode.org/cldr/charts/46/summary/root.html). For more information, see [Standardized codes](https://google.aip.dev/143). This field helps to better interpret the query. If a value isn't specified, the query language code is automatically detected, which may not be accurate. |
| `regionCode` | `string` Optional. The Unicode country/region code (CLDR) of a location, such as "US" and "419" [list](https://www.unicode.org/cldr/charts/46/supplemental/territory_information.html). For more information, see [Standardized codes](https://google.aip.dev/143). If set, then results will be boosted based on the regionCode provided. |
| `placeId` | `string` Optional. An id corresponding to a place, such as a store id or region id. When specified, we use the price from the local inventory with the matching product's `LocalInventory.place_id` for revenue optimization. Note, the currency of the local inventory's price must match the currency of the product's price. |
| `userAttributes` | ``map (key: string, value: object (`StringList`))`` Optional. The user attributes that could be used for personalization of search results. - Populate at most 100 key-value pairs per query. - Only supports string keys and repeated string values. - Duplicate keys are not allowed within a single query. Example: userAttributes: \[ { key: "pets" value { values: "dog" values: "cat" } }, { key: "state" value { values: "CA" } } \] |
| `spellCorrectionSpec` | ``object (`SpellCorrectionSpec`)`` The spell correction specification that specifies the mode under which spell correction will take effect. |

### Response body

If successful, the response body contains an instance of `SearchResponse`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication.md.txt#authorization-gcp).

### IAM Permissions

Requires **one of** the following [IAM](https://cloud.google.com/iam/docs) permissions on the `placement` resource, depending on the resource type:

- `retail.placements.search`
- `retail.servingConfigs.search`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).